#include "gc.h"
#include "display.h"
#include "display.h"
#include "error.h"
#include "config.h"

/*
GC = XCreateGC (dpy, win, valMask, XGCValues * in) ;
XCopyGC (dpy, srcGc, dstGc, valMask) ;
Status = XGetGCValues (dpy, gc, valMask, XGCValues * out) ;
XChangeGC (dpy, gc, valMask, XGCValues * in) ;
*/

typedef unsigned long Pixel ;

GC TextGC = 0 ;
GC DigitalGC = 0 ;
GC AnalogGoodGC = 0 ;
GC AnalogWarningGC = 0 ;
GC AnalogAlertGC = 0 ;

static Font font = 0 ;
static Pixel digitalColor = 0 ;
static Pixel analogGoodColor = 0 ;
static Pixel analogWarningColor = 0 ;
static Pixel analogAlertColor = 0 ;
static Pixel textColor = 0 ;
static Colormap cmap ;

static Pixel FindAllocRO (const char * name)
{
    XColor c ;

    if (XParseColor (Dpy, cmap, name, & c) == 0 ||
	XAllocColor (Dpy, cmap, & c) == 0)
    {
	error ("could not allocate color '%s'", name) ;
    }

    return c.pixel ;
}

extern void InitGC (void)
{
    XGCValues attr ;
    unsigned long attrMask ;
    Window root ;

    InitDisplay () ;

    root = DefaultRootWindow (Dpy) ;
    cmap = DefaultColormap (Dpy, Scr) ;

    font = XLoadFont (Dpy, FontName) ;

    digitalColor = FindAllocRO (DigitalColorName) ;
    analogGoodColor = FindAllocRO (AnalogGoodColorName) ;
    analogWarningColor = FindAllocRO (AnalogWarningColorName) ;
    analogAlertColor = FindAllocRO (AnalogAlertColorName) ;
    textColor = FindAllocRO (TextColorName) ;

    attrMask = GCFont | GCForeground ;
    attr.font = font ;

    attr.foreground = textColor ;
    TextGC = XCreateGC (Dpy, root, attrMask, & attr) ;
    attr.foreground = digitalColor ;
    DigitalGC = XCreateGC (Dpy, root, attrMask, & attr) ;
    attr.foreground = analogGoodColor ;
    AnalogGoodGC = XCreateGC (Dpy, root, attrMask, & attr) ;
    attr.foreground = analogWarningColor ;
    AnalogWarningGC = XCreateGC (Dpy, root, attrMask, & attr) ;
    attr.foreground = analogAlertColor ;
    AnalogAlertGC = XCreateGC (Dpy, root, attrMask, & attr) ;
}

