#include <assert.h>

#include "objects.h"

#define MAXOBJS 50

/* local view of the objects */
struct Object__
{
    Object_MethodsPtr methods ;
} ;

static Object_Ptr Objects [MAXOBJS] ;
static int NbObjects = 0 ;

extern void Object_Add (Object_Ptr obj)
{
    assert (obj != NULL) ;
    assert (NbObjects < MAXOBJS) ;
    Objects[NbObjects++] = obj ;
}

extern void Object_UpdateAll (void)
{
    int i ;
    Object_Ptr obj ;

    for (i=0; i<NbObjects; i++)
    {
	obj = Objects[i] ;
	obj->methods->update (obj) ;
    }
}

extern void Object_DrawAll (void)
{
    int i ;
    Object_Ptr obj ;

    for (i=0; i<NbObjects; i++)
    {
	obj = Objects[i] ;
	obj->methods->draw (obj) ;
    }
}

extern void Object_Parse (Object_Ptr obj, int valIndex, FILE * f)
{
    assert (obj != NULL) ;
    assert (f != NULL) ;
    obj->methods->parse (obj, valIndex, f) ;
}

